﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ADOnet
{
  public partial class Form1 : Form
  {

    private DataSet ds;
    private OleDbDataAdapter da;
    private OleDbCommand cmd;
    private OleDbConnection con;
    private OleDbParameter p;
    private BindingSource bs;

    public Form1()
    {
      InitializeComponent();
    }

    private void Form1_Load(object sender, EventArgs e)
    {
      openDb();
      ds = new DataSet();
      ds.Tables.Add("tbl1ds");
      da = new OleDbDataAdapter();
      cmd = con.CreateCommand();
      cmd.CommandText = "SELECT *FROM tbl1";
      da.SelectCommand = cmd;
      da.FillSchema(ds, SchemaType.Source, "tbl1ds");
      da.Fill(ds, "tbl1ds");
      bs = new BindingSource();
      bs.DataSource = ds.Tables[0];
      bsnav.BindingSource = bs;
      dgv1.DataSource = bs;
      daInsert();
      daUpdate();
      daDelete();
    }

    private void daInsert()
    {
      string strIns = "INSERT INTO tbl1(id, txt, dt, num) VALUES (?, ?, ?, ?)";
      OleDbCommand insertCmd = new OleDbCommand(strIns, con);
      da.InsertCommand = insertCmd;
      p = new OleDbParameter("@id", OleDbType.Integer);
      p.SourceColumn = "id";
      p.SourceVersion = DataRowVersion.Original;
      insertCmd.Parameters.Add(p);
      p = new OleDbParameter("@txt", OleDbType.VarChar);
      p.SourceColumn = "txt";
      p.SourceVersion = DataRowVersion.Original;
      insertCmd.Parameters.Add(p);
      p = new OleDbParameter("@dt", OleDbType.DBDate);
      p.SourceColumn = "dt";
      p.SourceVersion = DataRowVersion.Original;
      insertCmd.Parameters.Add(p);
      p = new OleDbParameter("@num", OleDbType.Integer);
      p.SourceColumn = "num";
      p.SourceVersion = DataRowVersion.Original;
      insertCmd.Parameters.Add(p);
    }

    private void daUpdate()
    {
      string strUpd = "UPDATE tbl1 SET txt = ?, dt = ?, num = ? WHERE id = ?"; 
      OleDbCommand updateCmd = new OleDbCommand(strUpd, con);
      da.UpdateCommand = updateCmd;
      p = new OleDbParameter("@txt", OleDbType.VarChar);
      p.SourceColumn = "txt";
      p.SourceVersion = DataRowVersion.Current;
      updateCmd.Parameters.Add(p);
      p = new OleDbParameter("@dt", OleDbType.DBDate);
      p.SourceColumn = "dt";
      p.SourceVersion = DataRowVersion.Current;
      updateCmd.Parameters.Add(p);
      p = new OleDbParameter("@num", OleDbType.Integer);
      p.SourceColumn = "num";
      p.SourceVersion = DataRowVersion.Current;
      updateCmd.Parameters.Add(p);
      p = new OleDbParameter("@id", OleDbType.Integer);
      p.SourceColumn = "id";
      p.SourceVersion = DataRowVersion.Current;
      updateCmd.Parameters.Add(p);
    }

    private void daDelete()
    {
      string strDel = "DELETE FROM tbl1 WHERE id = ?";
      OleDbCommand deleteCmd = new OleDbCommand(strDel, con);
      da.DeleteCommand = deleteCmd;
      p = new OleDbParameter("@id", OleDbType.Integer);
      p.SourceColumn = "id";
      p.SourceVersion = DataRowVersion.Current;
      deleteCmd.Parameters.Add(p);
    }

    private void openDb()
    {
      con = new OleDbConnection();
      con.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=.\\Adonet.mdb";
      try
      {
        con.Open();
      }
      catch
      {
        MessageBox.Show("Can't connect with AdoNet.mdb");
        Application.Exit();
      }
    }

    private void bindingNavigatorSaveItem_Click(object sender, EventArgs e)
    {
      da.Update(ds.Tables[0]);
    }

    private void bindingNavigatorAddNewItem_Click(object sender, EventArgs e)
    {
      bs.AddNew();
    }

    private void dgv1_CellClick(object sender, DataGridViewCellEventArgs e)
    {
      if (e.ColumnIndex == 2 && dgv1.CurrentCell.Value.ToString() == "")
      {
     // mc.Location = dgv1.CurrentCell..
        mc.Visible = true;
        mc.Show();
      }
      else
      {
        mc.Visible = false;
      }
    }

    private void mc_DateSelected(object sender, DateRangeEventArgs e)
    {
      dgv1.CurrentCell.Value = e.Start;
      mc.Visible = false;

    }
  }
}
